#ifndef __CFORTRAN_LOADED
#include "cfortran.h"
#endif

#include <stdio.h>

#include <TROOT.h>
#include "Results.h"
#include <TTree.h>
#include <TFile.h>

#ifndef WIN32
#define myusrini myusrini_
#else
#define myusrini MYUSRINI
#endif

static TFile *RootFile = 0;
static TTree *RootTree = 0;
static Results *TheResults = 0;

extern "C" {
  void myusrini (Double_t &pluto)
  {
    printf("Executing MYUSRINI\n");
    RootFile = new TFile("Out.root","recreate");
    RootTree = new TTree("ResultsTree","Protons");
    RootTree->Branch("Results", "Results", &TheResults, 64000, 1);

    printf("%f\n", pluto);

  }
}

#ifndef WIN32
#define treefill treefill_
#else
#define treefill TREEFILL
#endif

//	TParticle(Int_t pdg, Int_t status, Int_t mother1, Int_t mother2, Int_t daughter1, Int_t daughter2, Double_t px, Double_t py, Double_t pz, Double_t etot, Double_t vx, Double_t vy, Double_t vz, Double_t time);

extern "C" {
  void treefill(Int_t &pid, Int_t &NofInt, Double_t &etot, Double_t &ptot,  
		Double_t &px, Double_t &py, 
	        Double_t &pz, Double_t &time,
		Double_t &xx, Double_t &yy, Double_t &zz)
  {
    if (TheResults) {
      delete TheResults;
      TheResults = 0;
    }

    TheResults = new Results(pid, NofInt, etot, ptot, px, py, pz,
		     time, xx, yy, zz);

    RootTree->Fill();

  }

}

#ifndef WIN32
#define fileclose fileclose_
#else
#define fileclose FILECLOSE
#endif

extern "C" {
  void fileclose()
  {
    if (TheResults) {
      delete TheResults;
      TheResults = 0;
    }

    RootTree->Write();
    RootFile->Close();
  }
}

